package client;

import chat.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class SimpleChatClient extends _SimpleChatObserverImplBase {

  private SimpleChat chat = null;
  private User user = null;
  private JTextField tMsg = new JTextField("");
  private JButton bSend = new JButton("Send");
  private JTextArea taChat = new JTextArea();

  public SimpleChatClient() {
    super();

    JFrame f = new JFrame("SIMPLE CHAT");
    BorderLayout bL = new BorderLayout();
    f.getContentPane().setLayout(bL);

    JPanel p = new JPanel();
    BorderLayout bL1 = new BorderLayout();
    p.setLayout(bL1);
    p.add(tMsg, BorderLayout.CENTER);
    p.add(bSend, BorderLayout.EAST);

    taChat.setEditable(false);

    bSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Message msg = new Message(user, tMsg.getText());
        chat.sendMessage(msg);
      }
    });

    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        try {
          chat.unsubscribe(user);
        } catch (Exception ex) {}
        System.exit(0);
      }
    });

    f.getContentPane().add(p, BorderLayout.NORTH);
    JScrollPane sc = new JScrollPane(taChat);
    sc.setPreferredSize(new Dimension(470, 180));
    f.getContentPane().add(sc, BorderLayout.CENTER);

    f.pack();
    f.setVisible(true);
  }

  public void init(String userId) throws Exception {

    // Crea ed inizializza l'ORB
    ORB orb = ORB.init((String[])null, null);

    // Root naming context
    org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
    NamingContext ncRef = NamingContextHelper.narrow(objRef);

    // Utilizzo il Naming per ottenere il riferimento all'oggetto
    NameComponent nc = new NameComponent("SimpleChat", "");
    NameComponent path[] = {nc};
    chat = SimpleChatHelper.narrow(ncRef.resolve(path));

    // Si registra presso l'ORB
    // N.B. Il server deve essere in grado di effettuare 
    // un'invocazione remota del metodo callback.
    orb.connect(this);

    // Crea e registra user
    user = new User(userId, this);
    chat.subscribe(user);
  }

	// Metodo remoto di notifica invocato dal server
	public void callback(Message msg) {
    taChat.append("#" + msg.usr.userId + " - " + msg.msg + "\n");
    tMsg.setText("");
  }

  public static void main(String args[]) throws Exception {
    SimpleChatClient sc = new SimpleChatClient();
    sc.init(args[0]);
  }
}
