package server;

import chat.*;
import java.util.Hashtable;
import java.util.Enumeration;

public class SimpleChatImpl extends _SimpleChatImplBase {

  Hashtable h = new Hashtable();

  public SimpleChatImpl() {
    super();
  }

  // Aggiunge un utente alla chat
  public synchronized void subscribe(User user) {
    h.put(user.userId, user);

    Message msg = new Message(user, "Has joined the Chat.");
    this.sendMessage(msg);

    System.out.println("Added: " + user.userId);
  }

  // Rimuove un utente dalla chat
  public synchronized void unsubscribe(User user) {
    h.remove(user.userId);

    Message msg = new Message(user, "Left the Chat.");
    this.sendMessage(msg);

    System.out.println("Removed: " + user.userId);
  }

  // Invia il messaggio a tutti gli utenti
  public void sendMessage(Message msg) {
    User user = null;

		for (Enumeration e = h.elements(); e.hasMoreElements();) {
      user = (User) e.nextElement();

      // Invoca la callback
      try {
        user.callObj.callback(msg);
      } catch (Exception ex) {
        ex.printStackTrace();
      }
    }
  }

}
