package server;

import chat.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class SimpleChatServer {

  public static void main(String[] args) {

    try {

      // Inizializza l'ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

      // Crea un oggetto SimpleCHat
      SimpleChatImpl chat = new SimpleChatImpl();
      orb.connect(chat);

      // Stampa l'object reference in versione stringa
      System.out.println("Creata Chat: \n" + orb.object_to_string(chat));

      // Root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);

      // Fa il bind dell'oggetto nel Naming
      NameComponent nc = new NameComponent("SimpleChat", "");
      NameComponent path[] = {nc};
      ncRef.rebind(path, chat);

      // Attende l'invocazione di un client
      java.lang.Object sync = new java.lang.Object();
      synchronized (sync) {
        sync.wait();
      }

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}




